/**/
parse source scriptpath
scriptpath=word(scriptpath,3)
rpmroot=translate(filespec("path",scriptpath),'/','\')"root/";
rpmroot=substr(rpmroot,1,length(rpmroot)-1);
scriptpath=filespec("drive",scriptpath)||filespec("path",scriptpath)
scriptpath=substr(scriptpath,1,length(scriptpath)-1);
rc=directory(scriptpath)
'@set HOME='translate(scriptpath,'/','\')'/home'
'@set BEGINLIBPATH='scriptpath'/lib'
'@del testcase.log >nul 2>nul'
say "RPM/OS2 testcase. (c) Alex Samorukov, 2004"
say ""

tests.0=0;
test.name="tools/rpmsignature";
test.execstring.0=2;
test.execstring.1="@tools\rpmsignature.exe testfiles/zlib-1.1.4-8.8x.i386.rpm 2>>stderr.log |tools\dump 2>nul >testfiles/rpmsignature.out";
test.execstring.2="@tools\diff.exe testfiles/rpmsignature.out testfiles/rpmsignature.exp"
call addtest;

test.name="tools/rpmheader";
test.execstring.0=2;
test.execstring.1="@tools\rpmheader.exe testfiles/zlib-1.1.4-8.8x.i386.rpm 2>>stderr.log |tools\dump 2>nul >testfiles/rpmheader.out";
test.execstring.2="@tools\diff.exe testfiles/rpmheader.out testfiles/rpmheader.exp"
call addtest;

test.name="tools/rpmlead";
test.execstring.0=2;
test.execstring.1="@tools\rpmlead.exe testfiles/zlib-1.1.4-8.8x.i386.rpm 2>>stderr.log |tools\od >testfiles/rpmlead.out";
test.execstring.2="@tools\diff.exe testfiles/rpmlead.out testfiles/rpmlead.exp"
call addtest;

test.name="tools/rpmarchive";
test.execstring.0=2;
test.execstring.1="@tools\rpmarchive testfiles/zlib-1.1.4-8.8x.i386.rpm 2>>stderr.log |tools\zcat|tools\cpio --list --quiet >testfiles/rpmarchive.out";
test.execstring.2="@tools\diff.exe testfiles/rpmarchive.out testfiles/rpmarchive.exp"
call addtest;


test.name="rpm2cpio";
test.execstring.0=2;
test.execstring.1="@rpm2cpio testfiles/zlib-1.1.4-8.8x.i386.rpm 2>>stderr.log |tools\cpio --list --quiet >testfiles/rpm2cpio.out";
test.execstring.2="@tools\diff.exe testfiles/rpm2cpio.out testfiles/rpm2cpio.exp"
call addtest;

test.name="check_md5_sign";
test.execstring.0=1;
test.execstring.1="@rpm -K --nogpg testfiles/zlib-1.1.4-8.8x.i386.rpm >nul 2>stderr.log";
call addtest;

test.name="check_gpg_sign";
test.execstring.0=1;
test.execstring.1="@rpm -K --nomd5 testfiles/zlib-1.1.4-8.8x.i386.rpm >nul 2>stderr.log";
call addtest;
/* need to add more tests there... */

test.name="rpm_db_init";
test.execstring.0=2; /* --initdb return 0 even on a failures :-/ */
test.execstring.1="@rpm --root "rpmroot" --initdb 2>testfiles/rpm_db_init.out";
test.execstring.2="@tools\diff.exe testfiles/rpm_db_init.out testfiles/rpm_db_init.exp"
call addtest;

test.name="rpm_db_rebuild";
test.execstring.0=2; /* --rebuilddb return 0 even on a failures :-/ */
test.execstring.1="@rpm --root "rpmroot" --rebuilddb 2>testfiles/rpm_db_rebuild.out";
test.execstring.2="@tools\diff.exe testfiles/rpm_db_init.out testfiles/rpm_db_rebuild.exp"
call addtest;

test.name="rpm_db_create_ba";
test.execstring.0=1;
test.execstring.1="@rpm --root "rpmroot" -ba testfiles/test.spec 2>nul >nul";
call addtest;


do i=1 to tests.0
	test.name=tests.i.name;
	test.execstring.0=tests.i.execstring.0;
	do a=1 to tests.i.execstring.0
		test.execstring.a=tests.i.execstring.a
	end
	call runtest;
end



say ""
say "Results:"
exit 0;

addtest: procedure expose test. tests.
	tests.0=tests.0+1;
	i=tests.0
	tests.i.name=test.name;
	tests.i.execstring.0=test.execstring.0;
  do a=1 to test.execstring.0
  	tests.i.execstring.a=test.execstring.a;
  end

	return 0;
runtest: procedure expose test. result.
	call charout stdout,"    Starting test: "test.name": ";
  do i=1 to test.execstring.0
  	test.execstring.i
	if rc=0 then status="PASSED";
	else do
		 status="FAILED";
		 iterate;
	end

  end

	say status;
	call lineout "testcase.log","Test: "test.name": "status;
	return 0;

